﻿/*
Thor Server 2.0 Project - Codenamed "Stockholm"
Copyright 2008 - 2009 Joe Hegarty


This file is part of The Thor Server 2.0 Project - Codenamed "Stockholm".

The Thor Server 2.0 Project - Codenamed "Stockholm" is free software: you can 
redistribute it and/or modify it under the terms of the Microsoft Public License

The Thor Server Project is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Microsoft Public License for more details.

You should have received a copy of the Microsoft Public License
along with The Thor Server Project.  If not, see 
http://www.opensource.org/licenses/ms-pl.html
*/

using System;
using System.Collections.Generic;

using StockholmLibrary.Game.Flats;
using StockholmLibrary.Game.Sessions;
using StockholmLibrary.Game.Packets.Client;
using StockholmLibrary.Game.Packets.Server;
using StockholmLibrary.Net;

namespace StockholmLibrary.Game.Entities.Components
{
    //------------------------------------
    public class EntityComponentRoomChild : EntityComponent
    {
        //**********************************************
        protected void SendToCreatureSession(Entity entity, ServerPacket packet)
        {
            if (entity != null && packet != null)
            {
                ECSession ecSession = null;
                if (entity.GetEC(ref ecSession))
                {
                    ecSession.SendPacket(packet);
                }
            }
        }

        //**********************************************
        protected void SendToLocalSession(ServerPacket packet)
        {
            if (packet != null)
            {
                ECSession ecSession = null;
                if (GetParentEntity().GetEC(ref ecSession))
                {
                    ecSession.SendPacket(packet);
                }
            }
        }

        //**********************************************
        protected void SendToAllCreatureSessions(ServerPacket packet)
        {
            if (packet != null)
            {
                ECCreatureCollection ecCreatureCollection = null;
                if (GetRoomEntity().GetEC(ref ecCreatureCollection))
                {
                    ecCreatureCollection.SendToAllCreatureSessions(packet);
                }
            }
        }

        //**********************************************
        protected Entity GetRoomEntity()
        {
            // 2 Levels up from the EC to the room
            return GetParentEntity().GetParentEntity();
        }
    }
}
